#!/bin/tcsh
#PBS -N isovh1
#PBS -l nodes=65:ppn=8
#PBS -q default
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -M xukaishen@gmail.com
#PBS -e /net/server/xukai/huo/xukai1/report/12Spring/VTI_inversion/testisovh1.err
#PBS -o /net/server/xukai/huo/xukai1/report/12Spring/VTI_inversion/testisovh1.out
#
cd $PBS_O_WORKDIR
#

set DATDIR=/net/server/xukai/huo/xukai1/report/12Spring/VTI_inversion
set datapath=/net/server/xukai/huo/xukai1/report/12Spring/VTI_inversion
set CBIN=./Bin/c

cat ${PBS_NODEFILE} | sort | uniq > hostfileisovh1
set NPROCS=`wc -l hostfileisovh1 | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8

set str=isovh1

date

mpirun -machinefile ./hostfileisovh1 -np ${NPROCS} ${CBIN}/XC2dWIMPIMain.x <tmprcd1.H nxtape=40 nztape=40 vmin=600 vmax=5200 vout=${DATDIR}/newvel${str}.H resd=${DATDIR}/resd${str}.H vupd=${DATDIR}/vup${str}.H newsrc=${DATDIR}/newsrc${str}.H needspline=0 niter=80 needprecond=0 dxspline=100 dzspline=100 vel=velh0.H jrdful=9 jtmv=1 objtype=0 src=tmpsrc1.H thresd=0.000001 jnoderdful=1 rndbnd_type=0 j_rndbnd=5 alpha_mean=-0.03 alpha_sigma=0.05 alpha_maxV=0.0 sigma=600 rdfulpath=${datapath}/rdful${str}-inode- sdep=sdep1.H rdep=sdep1.H dwht=dwht1.H 

date
